Index: /pjproject/trunk/pjlib/include/pj/compat/os_winphone8.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/compat/os_winphone8.h	(revision 5539)
+++ /pjproject/trunk/pjlib/include/pj/compat/os_winphone8.h	(revision 5539)
@@ -0,0 +1,150 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJ_COMPAT_OS_WINPHONE8_H__
+#define __PJ_COMPAT_OS_WINPHONE8_H__
+
+/**
+ * @file os_winphone8.h
+ * @brief Describes Windows Phone 8 operating system family specifics.
+ */
+
+#define PJ_OS_NAME		    "winphone8"
+
+#define WIN32_LEAN_AND_MEAN
+#define RPC_NO_WINDOWS_H
+#define PJ_WIN32_WINNT		    0x0602 /*_WIN32_WINNT_WIN8*/
+#ifdef _WIN32_WINNT
+#undef _WIN32_WINNT
+#define _WIN32_WINNT		    PJ_WIN32_WINNT
+#endif
+
+#define PJ_HAS_ARPA_INET_H	    0
+#define PJ_HAS_ASSERT_H		    1
+#define PJ_HAS_CTYPE_H		    1
+#define PJ_HAS_ERRNO_H		    0   /* Must be zero, otherwise errno_test() fails. */
+#define PJ_HAS_LINUX_SOCKET_H	    0
+#define PJ_HAS_MALLOC_H		    1
+#define PJ_HAS_NETDB_H		    0
+#define PJ_HAS_NETINET_IN_H	    0
+#define PJ_HAS_NETINET_TCP_H	    0
+#define PJ_HAS_SETJMP_H		    1
+#define PJ_HAS_STDARG_H		    1
+#define PJ_HAS_STDDEF_H		    1
+#define PJ_HAS_STDIO_H		    1
+#define PJ_HAS_STDLIB_H		    1
+#define PJ_HAS_STRING_H		    1
+#define PJ_HAS_SYS_IOCTL_H	    0
+#define PJ_HAS_SYS_SELECT_H	    0
+#define PJ_HAS_SYS_SOCKET_H	    0
+#define PJ_HAS_SYS_TIME_H	    0
+#define PJ_HAS_SYS_TIMEB_H	    0	/* Doesn't have sys/timeb.h */
+#define PJ_HAS_SYS_TYPES_H	    0	/* Doesn't have sys/types.h */
+#define PJ_HAS_TIME_H		    1
+#define PJ_HAS_UNISTD_H		    0
+
+#define PJ_HAS_MSWSOCK_H	    1
+#define PJ_HAS_WINSOCK_H	    0
+#define PJ_HAS_WINSOCK2_H	    1
+
+#define PJ_SOCK_HAS_INET_ATON	    0
+
+/* Set 1 if native sockaddr_in has sin_len member. 
+ * Default: 0
+ */
+#define PJ_SOCKADDR_HAS_LEN	    0
+
+/* Is errno a good way to retrieve OS errors? (no)
+ */
+#define PJ_HAS_ERRNO_VAR	    0
+
+/* When this macro is set, getsockopt(SOL_SOCKET, SO_ERROR) will return
+ * the status of non-blocking connect() operation.
+ */
+#define PJ_HAS_SO_ERROR             0
+
+/* This value specifies the value set in errno by the OS when a non-blocking
+ * socket recv() or send() can not return immediately.
+ */
+#define PJ_BLOCKING_ERROR_VAL       WSAEWOULDBLOCK
+
+/* This value specifies the value set in errno by the OS when a non-blocking
+ * socket connect() can not get connected immediately.
+ */
+#define PJ_BLOCKING_CONNECT_ERROR_VAL   WSAEWOULDBLOCK
+
+/**
+ * If this macro is set, it tells select I/O Queue that select() needs to
+ * be given correct value of nfds (i.e. largest fd + 1). This requires
+ * select ioqueue to re-scan the descriptors on each registration and
+ * unregistration.
+ * If this macro is not set, then ioqueue will always give FD_SETSIZE for
+ * nfds argument when calling select().
+ *
+ * Default: 0
+ */
+#define PJ_SELECT_NEEDS_NFDS	    0
+
+/* Endianness */
+#ifndef PJ_IS_LITTLE_ENDIAN
+#   define PJ_IS_LITTLE_ENDIAN	1
+#   define PJ_IS_BIG_ENDIAN	0
+#endif
+
+/* Default threading is enabled, unless it's overridden. */
+#ifndef PJ_HAS_THREADS
+#  define PJ_HAS_THREADS	    (1)
+#endif
+
+#define PJ_HAS_HIGH_RES_TIMER	    1
+#define PJ_HAS_MALLOC               1
+#define PJ_OS_HAS_CHECK_STACK	    1
+
+#define PJ_ATOMIC_VALUE_TYPE	    long
+
+/* No console. */
+#define PJ_TERM_HAS_COLOR	    0
+
+/* TlsAlloc() error value. */
+#ifndef TLS_OUT_OF_INDEXES
+    #define TLS_OUT_OF_INDEXES	    0xFFFFFFFF
+#endif
+
+/* No rdtsc */
+#define PJ_TIMESTAMP_USE_RDTSC	    0
+
+/* Native string is Unicode. */
+#define PJ_NATIVE_STRING_IS_UNICODE 1
+
+/* If 1, use Read/Write mutex emulation for platforms that don't support it */
+#define PJ_EMULATE_RWMUTEX	    1
+
+/* If 1, pj_thread_create() should enforce the stack size when creating 
+ * threads.
+ * Default: 0 (let OS decide the thread's stack size).
+ */
+#define PJ_THREAD_SET_STACK_SIZE    	0
+
+/* If 1, pj_thread_create() should allocate stack from the pool supplied.
+ * Default: 0 (let OS allocate memory for thread's stack).
+ */
+#define PJ_THREAD_ALLOCATE_STACK    	0
+
+
+#endif	/* __PJ_COMPAT_OS_WINPHONE8_H__ */
Index: /pjproject/trunk/pjlib/include/pj/compat/os_winuwp.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/compat/os_winuwp.h	(revision 5539)
+++ /pjproject/trunk/pjlib/include/pj/compat/os_winuwp.h	(revision 5539)
@@ -0,0 +1,148 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJ_COMPAT_OS_UWP_H__
+#define __PJ_COMPAT_OS_UWP_H__
+
+/**
+ * @file os_winuwp.h
+ * @brief Describes Windows UWP operating system family specifics.
+ */
+
+#define PJ_OS_NAME		    "winuwp"
+
+#define WIN32_LEAN_AND_MEAN
+#define RPC_NO_WINDOWS_H
+#define PJ_WIN32_WINNT		    0x0602 /*_WIN32_WINNT_WIN8*/
+#ifdef _WIN32_WINNT
+#undef _WIN32_WINNT
+#define _WIN32_WINNT		    PJ_WIN32_WINNT
+#endif
+
+#define PJ_HAS_ARPA_INET_H	    0
+#define PJ_HAS_ASSERT_H		    1
+#define PJ_HAS_CTYPE_H		    1
+#define PJ_HAS_ERRNO_H		    0   /* Must be zero, otherwise errno_test() fails. */
+#define PJ_HAS_LINUX_SOCKET_H	    0
+#define PJ_HAS_MALLOC_H		    1
+#define PJ_HAS_NETDB_H		    0
+#define PJ_HAS_NETINET_IN_H	    0
+#define PJ_HAS_NETINET_TCP_H	    0
+#define PJ_HAS_SETJMP_H		    1
+#define PJ_HAS_STDARG_H		    1
+#define PJ_HAS_STDDEF_H		    1
+#define PJ_HAS_STDIO_H		    1
+#define PJ_HAS_STDLIB_H		    1
+#define PJ_HAS_STRING_H		    1
+#define PJ_HAS_SYS_IOCTL_H	    0
+#define PJ_HAS_SYS_SELECT_H	    0
+#define PJ_HAS_SYS_SOCKET_H	    0
+#define PJ_HAS_SYS_TIME_H	    0
+#define PJ_HAS_SYS_TIMEB_H	    0	/* Doesn't have sys/timeb.h */
+#define PJ_HAS_SYS_TYPES_H	    0	/* Doesn't have sys/types.h */
+#define PJ_HAS_TIME_H		    1
+#define PJ_HAS_UNISTD_H		    0
+
+#define PJ_HAS_MSWSOCK_H	    1
+#define PJ_HAS_WINSOCK_H	    0
+#define PJ_HAS_WINSOCK2_H	    1
+
+#define PJ_SOCK_HAS_INET_ATON	    0
+
+/* Set 1 if native sockaddr_in has sin_len member. 
+ * Default: 0
+ */
+#define PJ_SOCKADDR_HAS_LEN	    0
+
+/* Is errno a good way to retrieve OS errors? (no)
+ */
+#define PJ_HAS_ERRNO_VAR	    0
+
+/* When this macro is set, getsockopt(SOL_SOCKET, SO_ERROR) will return
+ * the status of non-blocking connect() operation.
+ */
+#define PJ_HAS_SO_ERROR             0
+
+/* This value specifies the value set in errno by the OS when a non-blocking
+ * socket recv() or send() can not return immediately.
+ */
+#define PJ_BLOCKING_ERROR_VAL       WSAEWOULDBLOCK
+
+/* This value specifies the value set in errno by the OS when a non-blocking
+ * socket connect() can not get connected immediately.
+ */
+#define PJ_BLOCKING_CONNECT_ERROR_VAL   WSAEWOULDBLOCK
+
+/**
+ * If this macro is set, it tells select I/O Queue that select() needs to
+ * be given correct value of nfds (i.e. largest fd + 1). This requires
+ * select ioqueue to re-scan the descriptors on each registration and
+ * unregistration.
+ * If this macro is not set, then ioqueue will always give FD_SETSIZE for
+ * nfds argument when calling select().
+ *
+ * Default: 0
+ */
+#define PJ_SELECT_NEEDS_NFDS	    0
+
+/* Endianness */
+#ifndef PJ_IS_LITTLE_ENDIAN
+#   define PJ_IS_LITTLE_ENDIAN	1
+#   define PJ_IS_BIG_ENDIAN	0
+#endif
+
+/* Default threading is enabled, unless it's overridden. */
+#ifndef PJ_HAS_THREADS
+#  define PJ_HAS_THREADS	    (1)
+#endif
+
+#define PJ_HAS_HIGH_RES_TIMER	    1
+#define PJ_HAS_MALLOC               1
+
+#ifndef PJ_OS_HAS_CHECK_STACK
+#   define PJ_OS_HAS_CHECK_STACK    0
+#endif
+
+#define PJ_ATOMIC_VALUE_TYPE	    long
+
+/* No console. */
+#define PJ_TERM_HAS_COLOR	    0
+
+/* No rdtsc */
+#define PJ_TIMESTAMP_USE_RDTSC	    0
+
+/* Native string is Unicode. */
+#define PJ_NATIVE_STRING_IS_UNICODE 1
+
+/* If 1, use Read/Write mutex emulation for platforms that don't support it */
+#define PJ_EMULATE_RWMUTEX	    1
+
+/* If 1, pj_thread_create() should enforce the stack size when creating 
+ * threads.
+ * Default: 0 (let OS decide the thread's stack size).
+ */
+#define PJ_THREAD_SET_STACK_SIZE    	0
+
+/* If 1, pj_thread_create() should allocate stack from the pool supplied.
+ * Default: 0 (let OS allocate memory for thread's stack).
+ */
+#define PJ_THREAD_ALLOCATE_STACK    	0
+
+
+#endif	/* __PJ_COMPAT_OS_UWP_H__ */
Index: /pjproject/trunk/pjlib/include/pj/config.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/config.h	(revision 5538)
+++ /pjproject/trunk/pjlib/include/pj/config.h	(revision 5539)
@@ -77,4 +77,29 @@
 #   define PJ_WIN32 1
 
+#elif defined(PJ_WIN32_WINPHONE8) || defined(_WIN32_WINPHONE8)
+    /*
+     * Windows Phone 8
+     */
+#   undef PJ_WIN32_WINPHONE8
+#   define PJ_WIN32_WINPHONE8   1
+#   include <pj/compat/os_winphone8.h>
+
+    /* Also define Win32 */
+#   define PJ_WIN32 1
+
+#elif defined(PJ_WIN32_UWP) || defined(_WIN32_UWP)
+    /*
+     * Windows UWP
+     */
+#   undef PJ_WIN32_UWP
+#   define PJ_WIN32_UWP   1
+#   include <pj/compat/os_winuwp.h>
+
+    /* Define Windows phone */
+#   define PJ_WIN32_WINPHONE8 1
+
+    /* Also define Win32 */
+#   define PJ_WIN32 1
+
 #elif defined(PJ_WIN32) || defined(_WIN32) || defined(__WIN32__) || \
 	defined(WIN32) || defined(PJ_WIN64) || defined(_WIN64) || \
@@ -237,16 +262,21 @@
 #   define PJ_IS_BIG_ENDIAN	1
 
-#elif defined (PJ_M_ARMV4) || defined(ARM) || defined(_ARM_) ||  \
-	defined(ARMV4) || defined(__arm__)
+#elif defined(ARM) || defined(_ARM_) ||  defined(__arm__) || defined(_M_ARM)
+#   define PJ_HAS_PENTIUM	0
     /*
      * ARM, bi-endian, so raise error if endianness is not configured
      */
-#   undef PJ_M_ARMV4
-#   define PJ_M_ARMV4		1
-#   define PJ_M_NAME		"armv4"
-#   define PJ_HAS_PENTIUM	0
 #   if !PJ_IS_LITTLE_ENDIAN && !PJ_IS_BIG_ENDIAN
 #   	error Endianness must be declared for this processor
 #   endif
+#   if defined (PJ_M_ARMV7) || defined(ARMV7)
+#	undef PJ_M_ARMV7
+#	define PJ_M_ARM7		1
+#	define PJ_M_NAME		"armv7"
+#   elif defined (PJ_M_ARMV4) || defined(ARMV4)
+#	undef PJ_M_ARMV4
+#	define PJ_M_ARMV4		1
+#	define PJ_M_NAME		"armv4"
+#   endif 
 
 #elif defined (PJ_M_POWERPC) || defined(__powerpc) || defined(__powerpc__) || \
Index: /pjproject/trunk/pjlib/src/pj/file_access_win32.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/file_access_win32.c	(revision 5538)
+++ /pjproject/trunk/pjlib/src/pj/file_access_win32.c	(revision 5539)
@@ -34,4 +34,55 @@
 #endif
 
+static pj_status_t get_file_size(HANDLE hFile, pj_off_t *size)
+{
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    FILE_COMPRESSION_INFO fileInfo;
+
+    if (GetFileInformationByHandleEx(hFile, FileCompressionInfo, &fileInfo,
+	sizeof(FILE_COMPRESSION_INFO)))
+    {
+	*size = fileInfo.CompressedFileSize.QuadPart;
+    }
+    else {
+	*size = -1;
+	return PJ_RETURN_OS_ERROR(GetLastError());
+    }
+#else
+    DWORD sizeLo, sizeHi;
+
+    sizeLo = GetFileSize(hFile, &sizeHi);
+    if (sizeLo == INVALID_FILE_SIZE) {
+	DWORD dwStatus = GetLastError();
+	if (dwStatus != NO_ERROR) {
+	    *size = -1;
+	    return PJ_RETURN_OS_ERROR(dwStatus);
+	}
+    }
+    *size = sizeHi;
+    *size = ((*size) << 32) + sizeLo;
+#endif
+    return PJ_SUCCESS;
+}
+
+static HANDLE WINAPI create_file(LPCTSTR filename, DWORD desired_access,
+    DWORD share_mode,
+    LPSECURITY_ATTRIBUTES security_attributes,
+    DWORD creation_disposition,
+    DWORD flags_and_attributes,
+    HANDLE template_file)
+{
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    PJ_UNUSED_ARG(security_attributes);
+    PJ_UNUSED_ARG(flags_and_attributes);
+    PJ_UNUSED_ARG(template_file);
+
+    return CreateFile2(filename, desired_access, share_mode,
+	creation_disposition, NULL);
+#else
+    return CreateFile(filename, desired_access, share_mode,
+		      security_attributes, creation_disposition,
+		      flags_and_attributes, template_file);
+#endif
+}
 
 /*
@@ -45,8 +96,9 @@
     PJ_ASSERT_RETURN(filename != NULL, 0);
 
-    hFile = CreateFile(PJ_STRING_TO_NATIVE(filename,wfilename,sizeof(wfilename)), 
-		       CONTROL_ACCESS, 
-		       FILE_SHARE_READ, NULL,
-                       OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
+    hFile = create_file(PJ_STRING_TO_NATIVE(filename,
+					    wfilename, sizeof(wfilename)),
+		        CONTROL_ACCESS, 
+		        FILE_SHARE_READ, NULL,
+                        OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
     if (hFile == INVALID_HANDLE_VALUE)
         return 0;
@@ -63,28 +115,18 @@
 {
     PJ_DECL_UNICODE_TEMP_BUF(wfilename,256)
-    HANDLE hFile;
-    DWORD sizeLo, sizeHi;
+    HANDLE hFile;    
     pj_off_t size;
 
     PJ_ASSERT_RETURN(filename != NULL, -1);
 
-    hFile = CreateFile(PJ_STRING_TO_NATIVE(filename, wfilename,sizeof(wfilename)), 
-		       CONTROL_ACCESS, 
-                       FILE_SHARE_READ | FILE_SHARE_WRITE, NULL,
-                       OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
+    hFile = create_file(PJ_STRING_TO_NATIVE(filename, 
+					    wfilename, sizeof(wfilename)),
+		        CONTROL_ACCESS, 
+                        FILE_SHARE_READ | FILE_SHARE_WRITE, NULL,
+                        OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
     if (hFile == INVALID_HANDLE_VALUE)
         return -1;
 
-    sizeLo = GetFileSize(hFile, &sizeHi);
-    if (sizeLo == INVALID_FILE_SIZE) {
-        DWORD dwStatus = GetLastError();
-        if (dwStatus != NO_ERROR) {
-            CloseHandle(hFile);
-            return -1;
-        }
-    }
-
-    size = sizeHi;
-    size = (size << 32) + sizeLo;
+    get_file_size(hFile, &size);
 
     CloseHandle(hFile);
@@ -139,10 +181,15 @@
                                          pj_time_val *time_val)
 {
+#if !defined(PJ_WIN32_WINPHONE8) || !PJ_WIN32_WINPHONE8
     FILETIME local_file_time;
+#endif
+
     SYSTEMTIME localTime;
     pj_parsed_time pt;
 
+#if !defined(PJ_WIN32_WINPHONE8) || !PJ_WIN32_WINPHONE8
     if (!FileTimeToLocalFileTime(file_time, &local_file_time))
 	return PJ_RETURN_OS_ERROR(GetLastError());
+#endif
 
     if (!FileTimeToSystemTime(file_time, &localTime))
@@ -173,33 +220,46 @@
     PJ_DECL_UNICODE_TEMP_BUF(wfilename,256)
     HANDLE hFile;
-    DWORD sizeLo, sizeHi;
     FILETIME creationTime, accessTime, writeTime;
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    FILE_BASIC_INFO fileInfo;
+#endif
 
     PJ_ASSERT_RETURN(filename!=NULL && stat!=NULL, PJ_EINVAL);
 
-    hFile = CreateFile(PJ_STRING_TO_NATIVE(filename,wfilename,sizeof(wfilename)), 
-		       CONTROL_ACCESS, 
-		       FILE_SHARE_READ, NULL,
-                       OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
+    hFile = create_file(PJ_STRING_TO_NATIVE(filename,
+					    wfilename, sizeof(wfilename)), 
+		        CONTROL_ACCESS, 
+		        FILE_SHARE_READ, NULL,
+                        OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
     if (hFile == INVALID_HANDLE_VALUE)
         return PJ_RETURN_OS_ERROR(GetLastError());
 
-    sizeLo = GetFileSize(hFile, &sizeHi);
-    if (sizeLo == INVALID_FILE_SIZE) {
-        DWORD dwStatus = GetLastError();
-        if (dwStatus != NO_ERROR) {
-            CloseHandle(hFile);
-            return PJ_RETURN_OS_ERROR(dwStatus);
-        }
-    }
-
-    stat->size = sizeHi;
-    stat->size = (stat->size << 32) + sizeLo;
-
-    if (GetFileTime(hFile, &creationTime, &accessTime, &writeTime)==FALSE) {
-        DWORD dwStatus = GetLastError();
-        CloseHandle(hFile);
-        return PJ_RETURN_OS_ERROR(dwStatus);
-    }
+    if (get_file_size(hFile, &stat->size) != PJ_SUCCESS) {
+	CloseHandle(hFile);
+	return PJ_RETURN_OS_ERROR(GetLastError());
+    }
+
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    if (GetFileInformationByHandleEx(hFile, FileBasicInfo, &fileInfo,
+	sizeof(FILE_BASIC_INFO)))
+    {
+	creationTime.dwLowDateTime = fileInfo.CreationTime.LowPart;
+	creationTime.dwHighDateTime = fileInfo.CreationTime.HighPart;
+	accessTime.dwLowDateTime = fileInfo.LastAccessTime.LowPart;
+	accessTime.dwHighDateTime = fileInfo.LastAccessTime.HighPart;
+	writeTime.dwLowDateTime = fileInfo.LastWriteTime.LowPart;
+	writeTime.dwHighDateTime = fileInfo.LastWriteTime.HighPart;
+    }
+    else {
+	CloseHandle(hFile);
+	return PJ_RETURN_OS_ERROR(GetLastError());
+    }
+#else
+    if (GetFileTime(hFile, &creationTime, &accessTime, &writeTime) == FALSE) {
+	DWORD dwStatus = GetLastError();
+	CloseHandle(hFile);
+	return PJ_RETURN_OS_ERROR(dwStatus);
+    }
+#endif
 
     CloseHandle(hFile);
Index: /pjproject/trunk/pjlib/src/pj/file_io_win32.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/file_io_win32.c	(revision 5538)
+++ /pjproject/trunk/pjlib/src/pj/file_io_win32.c	(revision 5539)
@@ -22,4 +22,5 @@
 #include <pj/errno.h>
 #include <pj/assert.h>
+#include <pj/string.h>
 
 #include <windows.h>
@@ -28,4 +29,37 @@
 #   define INVALID_SET_FILE_POINTER     ((DWORD)-1)
 #endif
+
+static pj_status_t set_file_pointer(pj_oshandle_t fd,
+    pj_off_t offset,
+    pj_off_t* newPos,
+    DWORD dwMoveMethod)
+{
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    LARGE_INTEGER liDistance, liNewPos;
+
+    liDistance.QuadPart = offset;
+    if (!SetFilePointerEx(fd, liDistance, &liNewPos, dwMoveMethod)) {
+	return PJ_RETURN_OS_ERROR(GetLastError());
+    }
+    *newPos = liNewPos.QuadPart;
+#else
+    DWORD dwNewPos;
+    LONG  hi32;
+
+    hi32 = (LONG)(offset >> 32);
+
+    dwNewPos = SetFilePointer(fd, (long)offset, &hi32, dwMoveMethod);
+    if (dwNewPos == (DWORD)INVALID_SET_FILE_POINTER) {
+	DWORD dwStatus = GetLastError();
+	if (dwStatus != 0)
+	    return PJ_RETURN_OS_ERROR(dwStatus);
+	/* dwNewPos actually is not an error. */
+    }
+    *newPos = hi32;
+    *newPos = (*newPos << 32) + dwNewPos;
+#endif
+
+    return PJ_SUCCESS;
+}
 
 /**
@@ -46,5 +80,5 @@
                                   pj_oshandle_t *fd)
 {
-    PJ_DECL_UNICODE_TEMP_BUF(wpathname,256)
+    PJ_DECL_UNICODE_TEMP_BUF(wpathname, 256)
     HANDLE hFile;
     DWORD dwDesiredAccess = 0;
@@ -87,12 +121,23 @@
 
     dwShareMode = FILE_SHARE_READ | FILE_SHARE_WRITE;
+    
     dwFlagsAndAttributes = FILE_ATTRIBUTE_NORMAL;
 
-    hFile = CreateFile(PJ_STRING_TO_NATIVE(pathname,wpathname,sizeof(wpathname)), 
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8  
+    hFile = CreateFile2(PJ_STRING_TO_NATIVE(pathname,
+			wpathname, sizeof(wpathname)),
+			dwDesiredAccess, dwShareMode, dwCreationDisposition,
+			NULL);
+#else
+    hFile = CreateFile(PJ_STRING_TO_NATIVE(pathname,
+		       wpathname, sizeof(wpathname)),
 		       dwDesiredAccess, dwShareMode, NULL,
-                       dwCreationDisposition, dwFlagsAndAttributes, NULL);
+		       dwCreationDisposition, dwFlagsAndAttributes, NULL);
+#endif
+
     if (hFile == INVALID_HANDLE_VALUE) {
+	DWORD lastErr = GetLastError();	
         *fd = 0;
-        return PJ_RETURN_OS_ERROR(GetLastError());
+        return PJ_RETURN_OS_ERROR(lastErr);
     }
 
@@ -181,6 +226,5 @@
 {
     DWORD dwMoveMethod;
-    DWORD dwNewPos;
-    LONG  hi32;
+    pj_off_t newPos;
 
     if (whence == PJ_SEEK_SET)
@@ -195,11 +239,6 @@
     }
 
-    hi32 = (LONG)(offset >> 32);
-    dwNewPos = SetFilePointer(fd, (long)offset, &hi32, dwMoveMethod);
-    if (dwNewPos == (DWORD)INVALID_SET_FILE_POINTER) {
-        DWORD dwStatus = GetLastError();
-        if (dwStatus != 0)
-            return PJ_RETURN_OS_ERROR(dwStatus);
-        /* dwNewPos actually is not an error. */
+    if (set_file_pointer(fd, offset, &newPos, dwMoveMethod) != PJ_SUCCESS) {
+	return PJ_RETURN_OS_ERROR(GetLastError());
     }
 
@@ -210,16 +249,8 @@
                                     pj_off_t *pos)
 {
-    LONG hi32 = 0;
-    DWORD lo32;
-
-    lo32 = SetFilePointer(fd, 0, &hi32, FILE_CURRENT);
-    if (lo32 == (DWORD)INVALID_SET_FILE_POINTER) {
-        DWORD dwStatus = GetLastError();
-        if (dwStatus != 0)
-            return PJ_RETURN_OS_ERROR(dwStatus);
-    }
-
-    *pos = hi32;
-    *pos = (*pos << 32) + lo32;
+    if (set_file_pointer(fd, 0, pos, FILE_CURRENT) != PJ_SUCCESS) {
+	return PJ_RETURN_OS_ERROR(GetLastError());
+    }
+
     return PJ_SUCCESS;
 }
Index: /pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.c	(revision 5538)
+++ /pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.c	(revision 5539)
@@ -116,8 +116,8 @@
     /* Create mutex for the key. */
 #if !PJ_IOQUEUE_HAS_SAFE_UNREG
-    rc = pj_lock_create_simple_mutex(poll, NULL, &key->lock);
-#endif
+    rc = pj_lock_create_simple_mutex(pool, NULL, &key->lock);
     if (rc != PJ_SUCCESS)
 	return rc;
+#endif
 
     /* Group lock */
Index: /pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.h
===================================================================
--- /pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.h	(revision 5538)
+++ /pjproject/trunk/pjlib/src/pj/ioqueue_common_abs.h	(revision 5539)
@@ -81,5 +81,5 @@
 union operation_key
 {
-    struct generic_operation generic;
+    struct generic_operation generic_op;
     struct read_operation    read;
     struct write_operation   write;
Index: /pjproject/trunk/pjlib/src/pj/ioqueue_select.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/ioqueue_select.c	(revision 5538)
+++ /pjproject/trunk/pjlib/src/pj/ioqueue_select.c	(revision 5539)
@@ -895,6 +895,19 @@
     pj_lock_release(ioqueue->lock);
 
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    count = 0;
+    __try {
+#endif
+
     count = pj_sock_select(nfds+1, &rfdset, &wfdset, &xfdset, 
 			   timeout);
+
+#if defined(PJ_WIN32_WINPHONE8) && PJ_WIN32_WINPHONE8
+    /* Ignore Invalid Handle Exception raised by select().*/
+    }
+    __except (GetExceptionCode() == STATUS_INVALID_HANDLE ?
+	      EXCEPTION_CONTINUE_EXECUTION : EXCEPTION_CONTINUE_SEARCH) {
+    }
+#endif    
     
     if (count == 0)
